unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, AdvUtil, Vcl.Grids, AdvObj, BaseGrid,
  AdvGrid, Vcl.StdCtrls;

type MainCourse = record  // Simulate master table
       Name : String[50];
       idx  : Integer;
     end;

type Ingrediants = record // Simulate detail table
       Idx     : Integer;
       Food    : String[50];
       Extra   : Boolean;
       Default : Boolean;
     end;

type
  TForm1 = class(TForm)
    Sg1: TAdvStringGrid;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Sg1CanEditCell(Sender: TObject; ARow, ACol: Integer;
      var CanEdit: Boolean);
    procedure Sg1CheckBoxClick(Sender: TObject; ACol, ARow: Integer;
      State: Boolean);
  private
    { Private declarations }

    TheCourse      : array of MainCourse;
    TheIngrediants : array of Ingrediants;

    Procedure SetGrid;
    procedure SetArray;
    procedure FillGrid;
    procedure SetNode(Grid: TAdvStringGrid; Column: Integer = 1);

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


procedure TForm1.FormCreate(Sender: TObject);
begin
  SetGrid;
  SetArray;
  FillGrid;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Finalize(TheCourse);
  Finalize(TheIngrediants);
end;


procedure TForm1.SetGrid;
begin
  Sg1.ColCount:=5;
  Sg1.Cells[1,0]:='Idx';
  Sg1.Cells[2,0]:='Dish';
  Sg1.Cells[3,0]:='Keep';
  Sg1.Cells[4,0]:='Extra';
end;

procedure TForm1.SetArray;
var I : Integer;
begin
  // Array for main course .... coul be your main table
  SetLength(TheCourse,6); // Only 5 main course .....
  TheCourse[0].idx:=0;
  TheCourse[0].Name:='Hamburger';
  TheCourse[1].idx:=1;
  TheCourse[1].Name:='Pizza';
  TheCourse[2].idx:=2;
  TheCourse[2].Name:='HotDog';
  TheCourse[3].idx:=3;
  TheCourse[3].Name:='Ramen';
  TheCourse[4].idx:=4;
  TheCourse[4].Name:='Sandwich';
  TheCourse[5].idx:=5;
  TheCourse[5].Name:='CocaCola';

  // Now set what kind of food we need ...
  SetLength(TheIngrediants,18); // This simulate some detail table records
  // Hamburger
  TheIngrediants[0].Idx:=0;
  TheIngrediants[0].Food:='Onion';
  TheIngrediants[0].Extra:=True;
  TheIngrediants[0].Default:=True;
  TheIngrediants[1].Idx:=0;
  TheIngrediants[1].Food:='Cheddar';
  TheIngrediants[1].Extra:=True;
  TheIngrediants[1].Default:=True;
  TheIngrediants[2].Idx:=0;
  TheIngrediants[2].Food:='Pickle';
  TheIngrediants[2].Extra:=False;
  TheIngrediants[2].Default:=True;

  // Pizza
  TheIngrediants[3].Idx:=1;
  TheIngrediants[3].Food:='Mozzarella';
  TheIngrediants[3].Extra:=True;
  TheIngrediants[3].Default:=True;
  TheIngrediants[4].Idx:=1;
  TheIngrediants[4].Food:='Olives';
  TheIngrediants[4].Extra:=True;
  TheIngrediants[4].Default:=True;
  TheIngrediants[5].Idx:=1;
  TheIngrediants[5].Food:='Anchovies';
  TheIngrediants[5].Extra:=False;
  TheIngrediants[5].Default:=True;
  TheIngrediants[6].Idx:=1;
  TheIngrediants[6].Food:='Ham';
  TheIngrediants[6].Extra:=False;
  TheIngrediants[6].Default:=True;

  // HotDog
  TheIngrediants[7].Idx:=2;
  TheIngrediants[7].Food:='Mustard';
  TheIngrediants[7].Extra:=False;
  TheIngrediants[7].Default:=True;
  TheIngrediants[8].Idx:=2;
  TheIngrediants[8].Food:='Ketchup';
  TheIngrediants[8].Extra:=False;
  TheIngrediants[8].Default:=True;

  // Ramen
  TheIngrediants[9].Idx:=3;
  TheIngrediants[9].Food:='Noodles';
  TheIngrediants[9].Extra:=True;
  TheIngrediants[9].Default:=True;
  TheIngrediants[10].Idx:=3;
  TheIngrediants[10].Food:='Seaweed';
  TheIngrediants[10].Extra:=False;
  TheIngrediants[10].Default:=True;
  TheIngrediants[11].Idx:=3;
  TheIngrediants[11].Food:='Meet';
  TheIngrediants[11].Extra:=True;
  TheIngrediants[11].Default:=True;
  TheIngrediants[12].Idx:=3;
  TheIngrediants[12].Food:='Fish';
  TheIngrediants[12].Extra:=True;
  TheIngrediants[12].Default:=True;

  // Sandwich
  TheIngrediants[13].Idx:=4;
  TheIngrediants[13].Food:='Mozzarella';
  TheIngrediants[13].Extra:=True;
  TheIngrediants[13].Default:=True;
  TheIngrediants[14].Idx:=4;
  TheIngrediants[14].Food:='Salad';
  TheIngrediants[14].Extra:=False;
  TheIngrediants[14].Default:=True;
  TheIngrediants[15].Idx:=4;
  TheIngrediants[15].Food:='Tomato';
  TheIngrediants[15].Extra:=False;
  TheIngrediants[15].Default:=True;
  TheIngrediants[16].Idx:=4;
  TheIngrediants[16].Food:='Ham';
  TheIngrediants[16].Extra:=True;
  TheIngrediants[16].Default:=True;

  // CocaCola
  TheIngrediants[17].Idx:=5;
  TheIngrediants[17].Food:='Ice';
  TheIngrediants[17].Extra:=False;
  TheIngrediants[17].Default:=True;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 SetNode(Sg1);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Sg1.IsHiddenColumn(1) then Sg1.UnHideColumn(1)
  else
  Sg1.HideColumn(1);
end;

procedure TForm1.FillGrid;
Var I,K : Integer;
begin
  Sg1.RowCount:=1;
  for I:=Low(TheCourse) to High(TheCourse) do
  begin
    Sg1.AddRow;
    // Insert The course ... in your case filter the master table for your search criteria
    Sg1.Ints[1,Sg1.LastRow]:=TheCourse[I].idx;
    Sg1.Cells[2,Sg1.LastRow]:=TheCourse[I].Name;
    // Now what is inside ??
    for K:=Low(TheIngrediants) to High(TheIngrediants) do
    begin
      if TheIngrediants[K].Idx=TheCourse[I].idx then
      begin
        Sg1.AddRow;
        Sg1.Ints[1,Sg1.LastRow]:=TheIngrediants[K].idx;
        Sg1.Cells[2,Sg1.LastRow]:=TheIngrediants[K].Food;
        Sg1.FontColors[2,Sg1.LastRow]:=clRed; // cosmetics ..
        Sg1.AddCheckBox(3,Sg1.LastRow,TheIngrediants[K].Default,False);
        Sg1.Alignments[3,Sg1.LastRow]:=taCenter;
        // check for exra ..
        if TheIngrediants[K].Extra then
        begin
        Sg1.AddCheckBox(4,Sg1.LastRow,TheIngrediants[K].Extra,False);
        Sg1.Alignments[4,Sg1.LastRow]:=taCenter;
        end;

      end;
    end;
  end;
  Sg1.AutoSizeColumns(True);
end;

procedure TForm1.SetNode(Grid: TAdvStringGrid; Column: Integer = 1);
var
  H, I, J: Integer;
begin
  I := 1;
  J := 1;
  while (I < Grid.RowCount - 1) do
  begin
    while (Grid.Cells[Column, J] = Grid.Cells[Column, J + 1]) and (J < Grid.RowCount - 1) do
      Inc(J);
    if (I <> J) then
    begin
      Grid.AddNode(I, J - I + 1);
      for H := I + 1 to J do
        Grid.Cells[Column, H] := '';
    end;
    I := J + 1;
    J := I;
  end;
end;

procedure TForm1.Sg1CanEditCell(Sender: TObject; ARow, ACol: Integer;
  var CanEdit: Boolean);
begin
  if (ACol=3) or (ACol=4) then
  begin
    if ACol=4 then
    begin
      Sg1.GetCheckBoxState(ACol - 1,ARow,CanEdit);
    end
    else
    CanEdit:=True
  End
  else
  CanEdit:=False;
end;

procedure TForm1.Sg1CheckBoxClick(Sender: TObject; ACol, ARow: Integer;
  State: Boolean);
begin
  Sg1.GetCheckBoxState(ACol,ARow,State); // Get Satate
  Sg1.SetCheckBoxState(ACol + 1,ARow,State);
end;

end.
